Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.Cli/Program.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.Cli/Program.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.Cli/Program.cs	(revision 14398)
@@ -12,5 +12,6 @@
         static void Main(string[] args)
         {
-            Stepwise().Wait();
+            SimpleTest();
+            //Stepwise().Wait();
             //PerformanceTestInterpreter();
             //PerformanceTestCodeGenerator();
@@ -18,4 +19,13 @@
             Console.WriteLine("\nPress any key to continue...");
             Console.ReadKey();
+        }
+
+        static void SimpleTest()
+        {
+            var interpreter = new PushGPInterpreter();
+
+            interpreter.Interpret("5 INTEGER.DUP INTEGER.+");
+
+            interpreter.PrintStacks();
         }
 
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/ExpressionNode.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/ExpressionNode.cs	(revision 14398)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/ExpressionNode.cs	(revision 14398)
@@ -0,0 +1,12 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.PushGP.Data
+{
+    public class ExpressionNode
+    {
+    }
+}
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/ExpressionTree.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/ExpressionTree.cs	(revision 14398)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/ExpressionTree.cs	(revision 14398)
@@ -0,0 +1,7 @@
+﻿namespace HeuristicLab.Algorithms.PushGP.Data
+{
+    public class ExpressionTree
+    {
+        public ExpressionNode Root { get; set; }
+    }
+}
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/ExpressionTable.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/ExpressionTable.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/ExpressionTable.cs	(revision 14398)
@@ -8,5 +8,5 @@
     public static class ExpressionTable
     {
-        private static Dictionary<string, Expression> expressionTable;
+        private static Dictionary<string, Expression> statelessExpressionTable;
         private static Dictionary<string, Func<Expression>> statefullExpressionFactory;
 
@@ -15,26 +15,27 @@
         static ExpressionTable()
         {
-            expressionTable = GetExperssionTable(e => e.ToString());
-            statefullExpressionFactory = GetStatefullExpressionFactory(e => e.ToString());
+            statelessExpressionTable = GetStatelessExperssionTable(e => e.StringRepresentation);
+            statefullExpressionFactory = GetStatefullExpressionFactory(e => e.StringRepresentation);
 
-            Count = expressionTable.Count + statefullExpressionFactory.Count;
+            Count = statelessExpressionTable.Count + statefullExpressionFactory.Count;
         }
 
-        private static Dictionary<string, Expression> GetExperssionTable(Func<Expression, string> keyFunc)
-        {
-            return GetExperssionTable(e => new KeyValuePair<string, Expression>(keyFunc(e), e));
-        }
-
-        private static Dictionary<string, Expression> GetExperssionTable(Func<Expression, KeyValuePair<string, Expression>> pairFunc)
+        private static Dictionary<string, Expression> GetStatelessExperssionTable(Func<Expression, string> keyFunc)
         {
             var dictionary = new Dictionary<string, Expression>();
-            var expressionTypes = GetExpressionTypes(filterStatefull: false);
+            var expressionTypes = GetExpressionTypes(typeof(StatelessExpression));
 
             foreach (var type in expressionTypes)
             {
-                var expression = (Expression)Activator.CreateInstance(type);
-                var pair = pairFunc(expression);
+                var expression = Activator.CreateInstance(type) as Expression;
+                var key = keyFunc(expression);
 
-                dictionary.Add(pair.Key, pair.Value);
+                try
+                {
+                    dictionary.Add(key, expression);
+                } catch(Exception e)
+                {
+                    Console.WriteLine(e);
+                }
             }
 
@@ -45,5 +46,5 @@
         {
             var dictionary = new Dictionary<string, Func<Expression>>();
-            var expressionTypes = GetExpressionTypes(filterStatefull: true);
+            var expressionTypes = GetExpressionTypes(typeof(StatefullExpression));
 
             foreach (var type in expressionTypes)
@@ -58,5 +59,12 @@
                 var key = keyFunc(expression);
 
-                dictionary.Add(key, creator);
+                try
+                {
+                    dictionary.Add(key, creator);
+                }
+                catch (Exception e)
+                {
+                    Console.WriteLine(e);
+                }
             }
 
@@ -64,17 +72,15 @@
         }
 
-        private static IEnumerable<Type> GetExpressionTypes(bool filterStatefull)
+        private static IEnumerable<Type> GetExpressionTypes(Type baseType)
         {
             return from domainAssembly in AppDomain.CurrentDomain.GetAssemblies()
                    from assemblyType in domainAssembly.GetTypes()
-                   let type = typeof(Expression)
                    where !assemblyType.IsAbstract &&
-                         assemblyType.IsSubclassOf(type) &&
-                         Attribute.IsDefined(assemblyType, typeof(StatefullExpressionAttribute)) == filterStatefull &&
+                         assemblyType.IsSubclassOf(baseType) &&
                          assemblyType.GetConstructor(Type.EmptyTypes) != null
                    select assemblyType;
         }
 
-        public static int StatelessCount { get { return expressionTable.Count; } }
+        public static int StatelessCount { get { return statelessExpressionTable.Count; } }
 
         public static int StatefullCount { get { return statefullExpressionFactory.Count; } }
@@ -83,5 +89,5 @@
         {
             return index < StatelessCount
-                ? expressionTable.ElementAt(index).Value
+                ? statelessExpressionTable.ElementAt(index).Value
                 : statefullExpressionFactory.ElementAt(index - StatelessCount).Value();
         }
@@ -102,5 +108,5 @@
         {
             Expression expression;
-            if (expressionTable.TryGetValue(symbol, out expression)) return expression;
+            if (statelessExpressionTable.TryGetValue(symbol, out expression)) return expression;
             else throw new NotSupportedException("Expression not supported: " + symbol);
         }
@@ -108,5 +114,5 @@
         public static bool TryGetStatelessExpression(string name, out Expression expression)
         {
-            return expressionTable.TryGetValue(name, out expression);
+            return statelessExpressionTable.TryGetValue(name, out expression);
         }
 
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/BooleanExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/BooleanExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/BooleanExpressions.cs	(revision 14398)
@@ -8,9 +8,12 @@
     public class BooleanAndExpression : PushResultExpression<bool>
     {
-        public BooleanAndExpression() : base("BOOLEAN.AND") { }
+        protected override string InitStringRepresentation()
+        {
+            return "BOOLEAN.AND";
+        }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.BooleanStack, 2, values => values[0] && values[1]);
+            Eval(interpreter.BooleanStack, 2, values => values[0] && values[1]);
         }
     }
@@ -21,9 +24,12 @@
     public class BooleanOrExpression : PushResultExpression<bool>
     {
-        public BooleanOrExpression() : base("BOOLEAN.OR") { }
+        protected override string InitStringRepresentation()
+        {
+            return "BOOLEAN.OR";
+        }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.BooleanStack, 2, values => values[0] || values[1]);
+            Eval(interpreter.BooleanStack, 2, values => values[0] || values[1]);
         }
     }
@@ -34,9 +40,9 @@
     public class BooleanNotExpression : PushResultExpression<bool>
     {
-        public BooleanNotExpression() : base("BOOLEAN.NOT") { }
+        protected override string InitStringRepresentation() { return "BOOLEAN.NOT"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.BooleanStack, 1, values => !values[0]);
+            Eval(interpreter.BooleanStack, 1, values => !values[0]);
         }
     }
@@ -45,7 +51,7 @@
     /// Pushes FALSE if the top FLOAT is 0.0, or TRUE otherwise.
     /// </summary>
-    public class BooleanFromFloatExpression : Expression
+    public class BooleanFromFloatExpression : StatelessExpression
     {
-        public BooleanFromFloatExpression() : base("BOOLEAN.FROMFLOAT") { }
+        protected override string InitStringRepresentation() { return "BOOLEAN.FROMFLOAT"; }
 
         public override void Eval(IInterpreter interpreter)
@@ -63,7 +69,7 @@
     /// Pushes FALSE if the top INTEGER is 0, or TRUE otherwise.
     /// </summary>
-    public class BooleanFromIntegerExpression : Expression
+    public class BooleanFromIntegerExpression : StatelessExpression
     {
-        public BooleanFromIntegerExpression() : base("BOOLEAN.FROMINTEGER") { }
+        protected override string InitStringRepresentation() { return "BOOLEAN.FROMINTEGER"; }
 
         public override void Eval(IInterpreter interpreter)
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/CodeExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/CodeExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/CodeExpressions.cs	(revision 14398)
@@ -17,7 +17,10 @@
     /// manipulates the stack then this final pop may end up popping something else.
     /// </summary>
-    public class CodeDoExpression : Expression
-    {
-        public CodeDoExpression() : base("CODE.DO") { }
+    public class CodeDoExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.DO";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -35,7 +38,10 @@
     /// Like CODE.DO but pops the stack before, rather than after, the recursive execution
     /// </summary>
-    public class CodeDoXExpression : Expression
-    {
-        public CodeDoXExpression() : base("CODE.DO*") { }
+    public class CodeDoXExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.DO*";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -53,7 +59,10 @@
     /// Does nothing.
     /// </summary>
-    public class CodeNoopExpression : Expression
-    {
-        public CodeNoopExpression() : base("CODE.NOOP") { }
+    public class CodeNoopExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.NOOP";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -67,7 +76,10 @@
     /// This can be implemented by moving the top item on the EXEC stack onto the CODE stack.
     /// </summary>
-    public class CodeQuoteExpression : Expression
-    {
-        public CodeQuoteExpression() : base("CODE.QUOTE") { }
+    public class CodeQuoteExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.QUOTE";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -87,7 +99,10 @@
     /// (and the BOOLEAN value upon which the decision was made) are popped.
     /// </summary>
-    public class CodeIfExpression : Expression
-    {
-        public CodeIfExpression() : base("CODE.IF") { }
+    public class CodeIfExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.IF";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -111,7 +126,10 @@
     /// literal (that is, something not surrounded by parentheses) then it is surrounded by parentheses first.
     /// </summary>
-    public class CodeAppendExpression : Expression
-    {
-        public CodeAppendExpression() : base("CODE.APPEND") { }
+    public class CodeAppendExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.APPEND";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -130,28 +148,28 @@
             if (isFirstList)
             {
-                var list1 = first as ExecExpandExpression;
+                var expand1 = first as ExecExpandExpression;
 
                 if (isSecondList)
                 {
-                    var list2 = second as ExecExpandExpression;
-
-                    result = new List<Expression>(list2.Expressions.Length + list1.Expressions.Length);
-                    result.AddRange(list2.Expressions);
-                    result.AddRange(list1.Expressions);
+                    var expand2 = second as ExecExpandExpression;
+
+                    result = new List<Expression>(expand2.Expressions.Length + expand1.Expressions.Length);
+                    result.AddRange(expand2.Expressions);
+                    result.AddRange(expand1.Expressions);
                 }
                 else
                 {
-                    result = new List<Expression>(list1.Expressions.Length + 1);
+                    result = new List<Expression>(expand1.Expressions.Length + 1);
                     result.Add(second);
-                    result.AddRange(list1.Expressions);
+                    result.AddRange(expand1.Expressions);
                 }
             }
             else if (isSecondList)
             {
-                var list2 = second as ExecExpandExpression;
-
-                result = new List<Expression>(list2.Expressions.Length + 1);
+                var expand2 = second as ExecExpandExpression;
+
+                result = new List<Expression>(expand2.Expressions.Length + 1);
                 result.Add(first);
-                result.AddRange(list2.Expressions);
+                result.AddRange(expand2.Expressions);
             }
             else
@@ -168,7 +186,10 @@
     /// and FALSE otherwise (that is, if it is something surrounded by parentheses).
     /// </summary>
-    public class CodeAtomExpression : Expression
-    {
-        public CodeAtomExpression() : base("CODE.ATOM") { }
+    public class CodeAtomExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.ATOM";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -189,7 +210,10 @@
     /// The name derives from the similar Lisp function; a more generic name would be "FIRST".
     /// </summary>
-    public class CodeCarExpression : Expression
-    {
-        public CodeCarExpression() : base("CODE.CAR") { }
+    public class CodeCarExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.CAR";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -216,7 +240,10 @@
     /// the similar Lisp function; a more generic name would be "REST".
     /// </summary>
-    public class CodeCdrExpression : Expression
-    {
-        public CodeCdrExpression() : base("CODE.CDR") { }
+    public class CodeCdrExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.CDR";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -230,7 +257,7 @@
             if (top.GetType() == typeof(ExecExpandExpression))
             {
-                var expression = top as ExecExpandExpression;
-
-                if (expression.Expressions.Length == 0)
+                var expand = top as ExecExpandExpression;
+
+                if (expand.IsEmpty)
                 {
                     return;
@@ -238,8 +265,8 @@
                 else
                 {
-                    var length = expression.Expressions.Length - 1;
+                    var length = expand.Expressions.Length - 1;
                     var newExpressions = new Expression[length];
 
-                    Array.Copy(expression.Expressions, 0, newExpressions, 0, length);
+                    Array.Copy(expand.Expressions, 0, newExpressions, 0, length);
 
                     expandExpression = new ExecExpandExpression(newExpressions);
@@ -260,7 +287,10 @@
     /// second piece of code is "X" then this pushes "( X A B )" (after popping the argument).
     /// </summary>
-    public class CodeConsExpression : Expression
-    {
-        public CodeConsExpression() : base("CODE.CONS") { }
+    public class CodeConsExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.CONS";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -286,7 +316,10 @@
     /// and the second piece of code is "( A )" then this pushes ( C ( A ) ). Pushes an empty list if there is no such container.
     /// </summary>
-    public class CodeContainerExpression : Expression
-    {
-        public CodeContainerExpression() : base("CODE.CONTAINER") { }
+    public class CodeContainerExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.CONTAINER";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -301,5 +334,5 @@
             var source = interpreter.CodeStack.Top;
 
-            var container = this.GetContainer(null, source as ExecExpandExpression, target);
+            var container = GetContainer(null, source as ExecExpandExpression, target);
             var result = container == null
                 ? ExecExpandExpression.Empty
@@ -330,7 +363,10 @@
     /// item anywhere (e.g. in a sub-list).
     /// </summary>
-    public class CodeContainsExpression : Expression
-    {
-        public CodeContainsExpression() : base("CODE.CONTAINS") { }
+    public class CodeContainsExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.CONTAINS";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -352,7 +388,10 @@
     /// may then be executed with a call to CODE.DO or a similar instruction).
     /// </summary>
-    public class CodeDefinitionExpression : Expression
-    {
-        public CodeDefinitionExpression() : base("CODE.DEFINITION") { }
+    public class CodeDefinitionExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.DEFINITION";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -385,7 +424,10 @@
     /// </list>
     /// </summary>
-    public class CodeDiscrepancyExpression : Expression
-    {
-        public CodeDiscrepancyExpression() : base("CODE.DISCREPANCY") { }
+    public class CodeDiscrepancyExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.DISCREPANCY";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -401,5 +443,5 @@
             DetermineUniqueItems(expressions[1], firstItems);
 
-            var discrepancy = this.GetDiscrepancy(firstItems, secondItems);
+            var discrepancy = GetDiscrepancy(firstItems, secondItems);
 
             interpreter.IntegerStack.Push(discrepancy);
@@ -434,7 +476,7 @@
             if (source.GetType() == typeof(ExecExpandExpression))
             {
-                var list = source as ExecExpandExpression;
-
-                foreach (var e in list.Expressions)
+                var expand = source as ExecExpandExpression;
+
+                foreach (var e in expand.Expressions)
                 {
                     var id = e.GetHashCode();
@@ -464,7 +506,10 @@
     /// absolute value is taken in case it is negative) to ensure that it is within the meaningful range.
     /// </summary>
-    public class CodeExtractExpression : Expression
-    {
-        public CodeExtractExpression() : base("CODE.EXTRACT") { }
+    public class CodeExtractExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.EXTRACT";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -488,7 +533,10 @@
     /// Pops the BOOLEAN stack and pushes the popped item (TRUE or FALSE) onto the CODE stack.
     /// </summary>
-    public class CodeFromBooleanExpression : Expression
-    {
-        public CodeFromBooleanExpression() : base("CODE.FROMBOOLEAN") { }
+    public class CodeFromBooleanExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.FROMBOOLEAN";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -507,7 +555,10 @@
     /// Pops the FLOAT stack and pushes the popped item onto the CODE stack.
     /// </summary>
-    public class CodeFromFloatExpression : Expression
-    {
-        public CodeFromFloatExpression() : base("CODE.FROMFLOAT") { }
+    public class CodeFromFloatExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.FROMFLOAT";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -526,7 +577,10 @@
     /// Pops the INTEGER stack and pushes the popped integer onto the CODE stack.
     /// </summary>
-    public class CodeFromIntegerExpression : Expression
-    {
-        public CodeFromIntegerExpression() : base("CODE.FROMINTEGER") { }
+    public class CodeFromIntegerExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.FROMINTEGER";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -545,7 +599,10 @@
     /// Pops the NAME stack and pushes the popped item onto the CODE stack.
     /// </summary>
-    public class CodeFromNameExpression : Expression
-    {
-        public CodeFromNameExpression() : base("CODE.FROMNAME") { }
+    public class CodeFromNameExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.FROMNAME";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -565,7 +622,10 @@
     /// by the top item of the INTEGER stack (and replacing whatever was there formerly).
     /// </summary>
-    public class CodeInsertExpression : Expression
-    {
-        public CodeInsertExpression() : base("CODE.INSERT") { }
+    public class CodeInsertExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.INSERT";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -602,7 +662,10 @@
     /// matter what they contain.
     /// </summary>
-    public class CodeLengthExpression : Expression
-    {
-        public CodeLengthExpression() : base("CODE.LENGTH") { }
+    public class CodeLengthExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.LENGTH";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -626,7 +689,10 @@
     /// Pushes a list of the top two items of the CODE stack onto the CODE stack.
     /// </summary>
-    public class CodeListExpression : Expression
-    {
-        public CodeListExpression() : base("CODE.LIST") { }
+    public class CodeListExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.LIST";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -652,7 +718,10 @@
     /// (which is coerced to a list if necessary). Pushes FALSE onto the BOOLEAN stack otherwise.
     /// </summary>
-    public class CodeMemberExpression : Expression
-    {
-        public CodeMemberExpression() : base("CODE.MEMBER") { }
+    public class CodeMemberExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.MEMBER";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -676,7 +745,10 @@
     /// modulo the length of the expression into which it is indexing.
     /// </summary>
-    public class CodeNthExpression : Expression
-    {
-        public CodeNthExpression() : base("CODE.NTH") { }
+    public class CodeNthExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.NTH";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -693,9 +765,9 @@
             if (expression.GetType() == typeof(ExecExpandExpression))
             {
-                var subExpressions = (expression as ExecExpandExpression).Expressions;
-
-                nthExpression = subExpressions.Length == 0
+                var subExpression = expression as ExecExpandExpression;
+
+                nthExpression = subExpression.IsEmpty
                     ? ExecExpandExpression.Empty
-                    : subExpressions[subExpressions.Length - 1 - Math.Abs(n % subExpressions.Length)];
+                    : subExpression.Expressions[subExpression.Expressions.Length - 1 - Math.Abs(n % subExpression.Expressions.Length)];
             }
             else
@@ -714,7 +786,10 @@
     /// its first element.
     /// </summary>
-    public class CodeNthCdrExpression : Expression
-    {
-        public CodeNthCdrExpression() : base("CODE.NTHCDR") { }
+    public class CodeNthCdrExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.NTHCDR";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -749,7 +824,10 @@
     /// Pushes TRUE onto the BOOLEAN stack if the top item of the CODE stack is an empty list, or FALSE otherwise.
     /// </summary>
-    public class CodeNullExpression : Expression
-    {
-        public CodeNullExpression() : base("CODE.NULL") { }
+    public class CodeNullExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.NULL";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -768,7 +846,10 @@
     /// (which is coerced to a list if necessary). Pushes -1 if no match is found.
     /// </summary>
-    public class CodePositionExpression : Expression
-    {
-        public CodePositionExpression() : base("CODE.POSITION") { }
+    public class CodePositionExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.POSITION";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -784,6 +865,6 @@
             if (first.GetType() == typeof(ExecExpandExpression))
             {
-                var list = first as ExecExpandExpression;
-                position = list.Expressions.Length - 1 - Array.FindIndex(list.Expressions, e => e.Equals(second));
+                var expand = first as ExecExpandExpression;
+                position = expand.Expressions.Length - 1 - Array.FindIndex(expand.Expressions, e => e.Equals(second));
             }
             else if (first.Equals(second))
@@ -800,7 +881,10 @@
     /// and pair of parentheses counts as a point.
     /// </summary>
-    public class CodeSizeExpression : Expression
-    {
-        public CodeSizeExpression() : base("CODE.SIZE") { }
+    public class CodeSizeExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.SIZE";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -824,7 +908,10 @@
     /// cases with empty-list arguments. If any of these problematic possibilities occurs the stack is left unchanged.
     /// </summary>
-    public class CodeSubstitutionExpression : Expression
-    {
-        public CodeSubstitutionExpression() : base("CODE.SUBST") { }
+    public class CodeSubstitutionExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.SUBST";
+        }
 
         public override void Eval(IInterpreter interpreter)
